//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_ProgramDialog.h"
#include "Moa_AutoPointers.h"
#include "Moa_Files.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppProgramDialog* AppProgramDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Button21Click(TObject* ASender)
{
	OpenDialog1->FileName = Input21;
	if(!OpenDialog1->Execute()) {
		Abort();
	}
	Input21 = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Button22Click(TObject* ASender)
{
	AnsiString LDirectory = Input24;
	if(!SelectDirectory("Choose the working directory.", WideString(), LDirectory)) {
		Abort();
	}
	SetCurrentDir(LDirectory);
	Input24 = LDirectory;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::ComboBox21Exit(TObject* ASender)
{
	Input25;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Edit11Exit(TObject* ASender)
{
	Input11;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Edit21Change(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Edit21Exit(TObject* ASender)
{
	Input21;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Edit24Exit(TObject* ASender)
{
	Input24;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Edit31Exit(TObject* ASender)
{
	Input31;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		UpdateValues();
	}
	ACanClose = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Initialize()
{
	try {
		FValues = new TProgramEntry();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Uninitialize()
{
	delete FValues;
	FValues = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::UpdateInputs()
{
	try {
		Input11 = Values->DisplayName;
		Input21 = Values->File;
		Input22 = Values->DocumentPrefix;
		Input23 = Values->DocumentSuffix;
		Input24 = Values->WorkingDirectory;
		Input25 = Values->ShowCommand;
		Input31 = Values->OpenInterval;
		Input32 = Values->AutoPause;
	}
	catch(...) {
		UpdateAccess();
		throw;
	}
	UpdateAccess();
	ActiveControl = NULL;
	SelectFirst();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::UpdateValues()
{
	try {
		TAutoPointer<TProgramEntry> LInputs = new TProgramEntry();
		LInputs->DisplayName = Input11;
		LInputs->File = Input21;
		LInputs->DocumentPrefix = Input22;
		LInputs->DocumentSuffix = Input23;
		LInputs->WorkingDirectory = Input24;
		LInputs->ShowCommand = Input25;
		LInputs->OpenInterval = Input31;
		LInputs->AutoPause = Input32;
		Values->Assign(LInputs);
	}
	catch(EProgramEntryCreateError& LException) {
		throw EInvalidInput("The program could not create a program entry.\r\n\r\nPlease correct the inputs.", Edit11);
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::UpdateAccess()
{
	Label23->Enabled = Edit21->Text.Length() > 0;
	Edit22->Enabled = Edit21->Text.Length() > 0;
	Label24->Enabled = Edit21->Text.Length() > 0;
	Edit23->Enabled = Edit21->Text.Length() > 0;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgramDialog::GetInput11()
{
	AnsiString LInput = Edit11->Text;
	if(LInput.Length() == 0 || !DoDisplayNameInput(LInput)) {
		throw EInvalidInput("Type a unique display name.", Edit11);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::SetInput11(const AnsiString& AInput)
{
	Edit11->Text = AInput;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgramDialog::GetInput21()
{
	AnsiString LInput = Edit21->Text;
	if(LInput.Length() > 0 && !TPathUtilities::IsAbsolute(LInput)) {
		throw EInvalidInput("Type an absolute path.", Edit21);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::SetInput21(const AnsiString& AInput)
{
	Edit21->Text = AInput;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgramDialog::GetInput22()
{
	return Edit22->Text;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::SetInput22(const AnsiString& AInput)
{
	Edit22->Text = AInput;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgramDialog::GetInput23()
{
	return Edit23->Text;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::SetInput23(const AnsiString& AInput)
{
	Edit23->Text = AInput;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppProgramDialog::GetInput24()
{
	AnsiString LInput = Edit24->Text;
	if(LInput.Length() > 0 && !TPathUtilities::IsAbsolute(LInput)) {
		throw EInvalidInput("Type an absolute path.", Edit24);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::SetInput24(const AnsiString& AInput)
{
	Edit24->Text = AInput;
}
//---------------------------------------------------------------------------
int __fastcall TAppProgramDialog::GetInput25()
{
	switch(ComboBox21->ItemIndex) {
	case 0:
		return SW_SHOWNORMAL;
	case 1:
		return SW_MINIMIZE;
	case 2:
		return SW_MAXIMIZE;
	default:
		throw EInvalidInput("Select an item.", ComboBox21);
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::SetInput25(int AInput)
{
	switch(AInput) {
	case SW_SHOWNORMAL:
		ComboBox21->ItemIndex = 0;
		break;
	case SW_MINIMIZE:
		ComboBox21->ItemIndex = 1;
		break;
	case SW_MAXIMIZE:
		ComboBox21->ItemIndex = 2;
		break;
	default:
		throw EInvalidValue("The program does not support the window state.");
	}
}
//---------------------------------------------------------------------------
int __fastcall TAppProgramDialog::GetInput31()
{
	int LInput = 0;
	if(!TryStrToInt(Edit31->Text, LInput) || LInput < 0) {
		throw EInvalidInput("Type an integer equal to or greater than 0.", Edit31);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::SetInput31(int AInput)
{
	Edit31->Text = AInput;
}
//---------------------------------------------------------------------------
bool __fastcall TAppProgramDialog::GetInput32()
{
	return CheckBox31->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::SetInput32(bool AInput)
{
	CheckBox31->Checked = AInput;
}
//---------------------------------------------------------------------------
bool __fastcall TAppProgramDialog::DoDisplayNameInput(const AnsiString& ADisplayName)
{
	bool LAccept = true;
	if(OnDisplayNameInput != NULL) {
		OnDisplayNameInput(this, ADisplayName, LAccept);
	}
	return LAccept;
}
//---------------------------------------------------------------------------
__fastcall TAppProgramDialog::TAppProgramDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues(NULL),
	FOnDisplayNameInput(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TAppProgramDialog::~TAppProgramDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
TAppProgramDialog* __fastcall TAppProgramDialog::EnsureCreated()
{
	if(AppProgramDialog == NULL) {
		AppProgramDialog = new TAppProgramDialog(Application);
	}
	return AppProgramDialog;
}
//---------------------------------------------------------------------------
bool __fastcall TAppProgramDialog::Execute()
{
	UpdateInputs();
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgramDialog::Reset()
{
	TAutoPointer<TProgramEntry> LDefaultValues = new TProgramEntry();
	LDefaultValues->DisplayName = "Untitled";
	LDefaultValues->File = AnsiString();
	LDefaultValues->DocumentPrefix = "\"";
	LDefaultValues->DocumentSuffix = "\"";
	LDefaultValues->WorkingDirectory = AnsiString();
	LDefaultValues->ShowCommand = SW_SHOWNORMAL;
	LDefaultValues->OpenInterval = 0;
	LDefaultValues->AutoPause = false;
	Values->Assign(LDefaultValues);
}
//---------------------------------------------------------------------------

