//----------------------------------------------------------------------------
#ifndef App_ProgramDialogH
#define App_ProgramDialogH
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <Dialogs.hpp>
#include <FileCtrl.hpp>
#include <StdCtrls.hpp>
#include "App_Programs.h"
//---------------------------------------------------------------------------
namespace App_programdialog {
//---------------------------------------------------------------------------
typedef void __fastcall (__closure * TDisplayNameInputEvent)(TObject* ASender, const AnsiString& ADisplayName, bool& AAccept);
//---------------------------------------------------------------------------
} // End namespace App_programdialog
using namespace App_programdialog;
//---------------------------------------------------------------------------
class TAppProgramDialog : public TForm
{
__published:
	TButton* Button1;
	TButton* Button2;
	TButton* Button21;
	TButton* Button22;
	TCheckBox* CheckBox31;
	TComboBox* ComboBox21;
	TEdit* Edit11;
	TEdit* Edit21;
	TEdit* Edit22;
	TEdit* Edit23;
	TEdit* Edit24;
	TEdit* Edit31;
	TGroupBox* GroupBox1;
	TGroupBox* GroupBox2;
	TGroupBox* GroupBox3;
	TLabel* Label11;
	TLabel* Label21;
	TLabel* Label22;
	TLabel* Label23;
	TLabel* Label24;
	TLabel* Label25;
	TLabel* Label26;
	TLabel* Label27;
	TLabel* Label31;
	TOpenDialog* OpenDialog1;
	void __fastcall Button21Click(TObject* ASender);
	void __fastcall Button22Click(TObject* ASender);
	void __fastcall ComboBox21Exit(TObject* ASender);
	void __fastcall Edit11Exit(TObject* ASender);
	void __fastcall Edit21Change(TObject* ASender);
	void __fastcall Edit21Exit(TObject* ASender);
	void __fastcall Edit24Exit(TObject* ASender);
	void __fastcall Edit31Exit(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
private:
	class EInvalidInput : public EAppError
	{
	public:
		__fastcall EInvalidInput(const AnsiString& AMessage, TWinControl* AControl) : EAppError(AMessage)
		{
			AControl->SetFocus();
		}
	};
	class EInvalidValue : public EAppError
	{
	public:
		__fastcall EInvalidValue(const AnsiString& AMessage) : EAppError(AMessage) {}
	};
	TProgramEntry* FValues;
	TDisplayNameInputEvent FOnDisplayNameInput;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall UpdateInputs();
	void __fastcall UpdateValues();
	void __fastcall UpdateAccess();
	AnsiString __fastcall GetInput11();
	void __fastcall SetInput11(const AnsiString& AInput);
	AnsiString __fastcall GetInput21();
	void __fastcall SetInput21(const AnsiString& AInput);
	AnsiString __fastcall GetInput22();
	void __fastcall SetInput22(const AnsiString& AInput);
	AnsiString __fastcall GetInput23();
	void __fastcall SetInput23(const AnsiString& AInput);
	AnsiString __fastcall GetInput24();
	void __fastcall SetInput24(const AnsiString& AInput);
	int __fastcall GetInput25();
	void __fastcall SetInput25(int AInput);
	int __fastcall GetInput31();
	void __fastcall SetInput31(int AInput);
	bool __fastcall GetInput32();
	void __fastcall SetInput32(bool AInput);
	__property AnsiString Input11 = {read=GetInput11, write=SetInput11};
	__property AnsiString Input21 = {read=GetInput21, write=SetInput21};
	__property AnsiString Input22 = {read=GetInput22, write=SetInput22};
	__property AnsiString Input23 = {read=GetInput23, write=SetInput23};
	__property AnsiString Input24 = {read=GetInput24, write=SetInput24};
	__property int Input25 = {read=GetInput25, write=SetInput25};
	__property int Input31 = {read=GetInput31, write=SetInput31};
	__property bool Input32 = {read=GetInput32, write=SetInput32};
protected:
	virtual bool __fastcall DoDisplayNameInput(const AnsiString& ADisplayName);
public:
	__fastcall TAppProgramDialog(TComponent* AOwner);
	virtual __fastcall ~TAppProgramDialog();
	static TAppProgramDialog* __fastcall EnsureCreated();
	virtual bool __fastcall Execute();
	virtual void __fastcall Reset();
	__property TProgramEntry* Values = {read=FValues, write=FValues};
	__property TDisplayNameInputEvent OnDisplayNameInput = {read=FOnDisplayNameInput, write=FOnDisplayNameInput};
};
//----------------------------------------------------------------------------
extern PACKAGE TAppProgramDialog* AppProgramDialog;
//----------------------------------------------------------------------------
#endif

