//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_ProgressDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppProgressDialog* AppProgressDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	ACanClose = false;
	if(ModalResult != mrOk) {
		DoCancel();
		return;
	}
	ACanClose = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Button1Click(TObject* ASender)
{
	DoPause();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Button2Click(TObject* ASender)
{
	DoResume();
}
//---------------------------------------------------------------------------
bool __fastcall TAppProgressDialog::GetPauseEnabled()
{
	return Button1->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::SetPauseEnabled(bool APauseEnabled)
{
	Button1->Enabled = APauseEnabled;
}
//---------------------------------------------------------------------------
bool __fastcall TAppProgressDialog::GetResumeEnabled()
{
	return Button2->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::SetResumeEnabled(bool AResumeEnabled)
{
	Button2->Enabled = AResumeEnabled;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::DoPause()
{
	if(OnPause != NULL) {
		OnPause(this);
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::DoResume()
{
	if(OnResume != NULL) {
		OnResume(this);
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::DoCancel()
{
	if(OnCancel != NULL) {
		OnCancel(this);
	}
}
//---------------------------------------------------------------------------
__fastcall TAppProgressDialog::TAppProgressDialog(TComponent* AOwner) :
	TForm(AOwner),
	FOnPause(NULL),
	FOnResume(NULL),
	FOnCancel(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAppProgressDialog::~TAppProgressDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TAppProgressDialog* __fastcall TAppProgressDialog::EnsureCreated()
{
	if(AppProgressDialog == NULL) {
		AppProgressDialog = new TAppProgressDialog(Application);
	}
	return AppProgressDialog;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Execute()
{
	Reset();
	ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Finish()
{
	ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::Reset()
{
	ShowInformation(AnsiString());
	ShowParameters(AnsiString(), AnsiString());
	ShowProgress(0, 100);
	PauseEnabled = true;
	ResumeEnabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::ShowInformation(const AnsiString& AMessage)
{
	Image1->Visible = true;
	Image2->Visible = false;
	Image3->Visible = false;
	Label1->Caption = AMessage;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::ShowWarning(const AnsiString& AMessage)
{
	Image1->Visible = false;
	Image2->Visible = true;
	Image3->Visible = false;
	Label1->Caption = AMessage;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::ShowError(const AnsiString& AMessage)
{
	Image1->Visible = false;
	Image2->Visible = false;
	Image3->Visible = true;
	Label1->Caption = AMessage;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::ShowParameters(const AnsiString& AProgram, const AnsiString& ADocument)
{
	Label3->Caption = AProgram;
	Label5->Caption = ADocument;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::ShowProgress(int ACurrent, int AAll)
{
	ProgressBar->Min = 0;
	ProgressBar->Max = AAll;
	ProgressBar->Position = ACurrent;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::HandleTerminate(TObject* ASender)
{
	Finish();
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::HandleNext(TObject* ASender, const AnsiString& AProgram, const AnsiString& ADocument)
{
	ShowParameters(AProgram, ADocument);
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::HandlePause(TObject* ASender)
{
	PauseEnabled = false;
	ResumeEnabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::HandleResume(TObject* ASender)
{
	PauseEnabled = true;
	ResumeEnabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::HandleInformation(TObject* ASender, const AnsiString& AMessage)
{
	ShowInformation(AMessage);
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::HandleWarning(TObject* ASender, const AnsiString& AMessage)
{
	ShowWarning(AMessage);
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::HandleError(TObject* ASender, const AnsiString& AMessage)
{
	ShowError(AMessage);
}
//---------------------------------------------------------------------------
void __fastcall TAppProgressDialog::HandleProgress(TObject* ASender, int ACurrent, int AAll)
{
	ShowProgress(ACurrent, AAll);
}
//---------------------------------------------------------------------------

