//---------------------------------------------------------------------------
#ifndef App_ProgressDialogH
#define App_ProgressDialogH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <StdCtrls.hpp>
#include "App_Common.h"
//---------------------------------------------------------------------------
class TAppProgressDialog : public TForm
{
__published:
	TButton* Button1;
	TButton* Button2;
	TButton* Button3;
	TImage* Image1;
	TImage* Image2;
	TImage* Image3;
	TLabel* Label5;
	TLabel* Label1;
	TLabel* Label2;
	TLabel* Label3;
	TLabel* Label4;
	TProgressBar* ProgressBar;
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall Button1Click(TObject* ASender);
	void __fastcall Button2Click(TObject* ASender);
private:
	TNotifyEvent FOnPause;
	TNotifyEvent FOnResume;
	TNotifyEvent FOnCancel;
	bool __fastcall GetPauseEnabled();
	void __fastcall SetPauseEnabled(bool APauseEnabled);
	bool __fastcall GetResumeEnabled();
	void __fastcall SetResumeEnabled(bool AResumeEnabled);
protected:
	virtual void __fastcall DoPause();
	virtual void __fastcall DoResume();
	virtual void __fastcall DoCancel();
public:
	__fastcall TAppProgressDialog(TComponent* AOwner);
	virtual __fastcall ~TAppProgressDialog();
	static TAppProgressDialog* __fastcall EnsureCreated();
	virtual void __fastcall Execute();
	virtual void __fastcall Finish();
	virtual void __fastcall Reset();
	virtual void __fastcall ShowInformation(const AnsiString& AMessage);
	virtual void __fastcall ShowWarning(const AnsiString& AMessage);
	virtual void __fastcall ShowError(const AnsiString& AMessage);
	virtual void __fastcall ShowParameters(const AnsiString& AProgram, const AnsiString& ADocument);
	virtual void __fastcall ShowProgress(int ACurrent, int AAll);
	virtual void __fastcall HandleTerminate(TObject* ASender);
	virtual void __fastcall HandleNext(TObject* ASender, const AnsiString& AProgram, const AnsiString& ADocument);
	virtual void __fastcall HandlePause(TObject* ASender);
	virtual void __fastcall HandleResume(TObject* ASender);
	virtual void __fastcall HandleInformation(TObject* ASender, const AnsiString& AMessage);
	virtual void __fastcall HandleWarning(TObject* ASender, const AnsiString& AMessage);
	virtual void __fastcall HandleError(TObject* ASender, const AnsiString& AMessage);
	virtual void __fastcall HandleProgress(TObject* ASender, int ACurrent, int AAll);
	__property bool PauseEnabled = {read=GetPauseEnabled, write=SetPauseEnabled};
	__property bool ResumeEnabled = {read=GetResumeEnabled, write=SetResumeEnabled};
	__property TNotifyEvent OnPause = {read=FOnPause, write=FOnPause};
	__property TNotifyEvent OnResume = {read=FOnResume, write=FOnResume};
	__property TNotifyEvent OnCancel = {read=FOnCancel, write=FOnCancel};
};
//---------------------------------------------------------------------------
extern PACKAGE TAppProgressDialog* AppProgressDialog;
//---------------------------------------------------------------------------
#endif

