//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <ComCtrls.hpp>
#include <Forms.hpp>
#include <IniFiles.hpp>
#include "App_View.h"
#include "Moa_Forms.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_view {
//---------------------------------------------------------------------------
__fastcall TFormModel::TFormModel(TForm* AForm) :
	TModel(),
	FForm(AForm)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFormModel::~TFormModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TFormModel::LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	AnsiString LSection = ASection + ".BoundsRect";
	{
		TRect LBounds = TFormUtilities::GetNormalBounds(Form);
		LBounds.left = ASettings->ReadInteger(
			LSection,
			"Left",
			LBounds.left);
		LBounds.top = ASettings->ReadInteger(
			LSection,
			"Top",
			LBounds.top);
		LBounds.right = ASettings->ReadInteger(
			LSection,
			"Right",
			LBounds.right);
		LBounds.bottom = ASettings->ReadInteger(
			LSection,
			"Bottom",
			LBounds.bottom);
		TFormUtilities::SetNormalBounds(Form, LBounds);
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormModel::SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	AnsiString LSection = ASection + ".BoundsRect";
	{
		TRect LBounds = TFormUtilities::GetNormalBounds(Form);
		ASettings->WriteInteger(
			LSection,
			"Left",
			LBounds.left);
		ASettings->WriteInteger(
			LSection,
			"Top",
			LBounds.top);
		ASettings->WriteInteger(
			LSection,
			"Right",
			LBounds.right);
		ASettings->WriteInteger(
			LSection,
			"Bottom",
			LBounds.bottom);
	}
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TListViewModel::TListViewModel(TListView* AListView) :
	TModel(),
	FListView(AListView)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TListViewModel::~TListViewModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TListViewModel::LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	AnsiString LSection = ASection + ".Columns";
	for(int LI = 0; LI < ListView->Columns->Count; ++LI) {
		ListView->Columns->Items[LI]->Width = ASettings->ReadInteger(
			LSection + AnsiString().sprintf(".Items[%d}", LI),
			"Width",
			ListView->Columns->Items[LI]->Width);
	}
}
//---------------------------------------------------------------------------
void __fastcall TListViewModel::SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	AnsiString LSection = ASection + ".Columns";
	for(int LI = 0; LI < ListView->Columns->Count; ++LI) {
		ASettings->WriteInteger(
			LSection + AnsiString().sprintf(".Items[%d}", LI),
			"Width",
			ListView->Columns->Items[LI]->Width);
	}
}
//---------------------------------------------------------------------------
} // End namespace App_view
//---------------------------------------------------------------------------

