//---------------------------------------------------------------------------
#ifndef Moa_StringsH
#define Moa_StringsH
//---------------------------------------------------------------------------
// Version: 1.2.0
// Date: 2012-06-02 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_strings {
//---------------------------------------------------------------------------
class EStringError : public Exception
{
public:
	__fastcall EStringError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TAnsiStringUtilities : public TObject
{
private:
protected:
public:
	static AnsiString __fastcall Quote(const AnsiString& AString, char AQuoteCharacter = '\"');
	static AnsiString __fastcall Dequote(const AnsiString& AString, char AQuoteCharacter = '\"');
	static AnsiString __fastcall Replace(const AnsiString& AString, const AnsiString& AOldString, const AnsiString& ANewString, bool ACaseSensitive, bool AReplaceAll);
	static AnsiString __fastcall CommaTextToText(const AnsiString& ACommaText);
	static AnsiString __fastcall TextToCommaText(const AnsiString& AText);
	static AnsiString __fastcall DelimitedTextToText(const AnsiString& ADelimitedText, char ADelimiter, char AQuoteCharacter);
	static AnsiString __fastcall TextToDelimitedText(const AnsiString& AText, char ADelimiter, char AQuoteCharacter);
	static DynamicArray<AnsiString> __fastcall CommaTextToArray(const AnsiString& ACommaText);
	static AnsiString __fastcall ArrayToCommaText(const DynamicArray<AnsiString>& AArray);
	static DynamicArray<AnsiString> __fastcall DelimitedTextToArray(const AnsiString& ADelimitedText, char ADelimiter, char AQuoteCharacter);
	static AnsiString __fastcall ArrayToDelimitedText(const DynamicArray<AnsiString>& AArray, char ADelimiter, char AQuoteCharacter);
	static AnsiString __fastcall FormatInteger(int AInteger, int AGroupDigits = 3, const AnsiString& LGroupSeparator = ',');
	static AnsiString __fastcall FormatInteger(__int64 AInteger, int AGroupDigits = 3, const AnsiString& LGroupSeparator = ',');
	static AnsiString __fastcall FormatInteger(unsigned int AInteger, int AGroupDigits = 3, const AnsiString& LGroupSeparator = ',');
	static AnsiString __fastcall FormatInteger(unsigned __int64 AInteger, int AGroupDigits = 3, const AnsiString& LGroupSeparator = ',');
};
//---------------------------------------------------------------------------
} // End namespace Moa_strings
using namespace Moa_strings;
//---------------------------------------------------------------------------
#endif

